javax.jms

## Interface ConnectionFactory

- All Known Subinterfaces:
    QueueConnectionFactory, TopicConnectionFactory, XAQueueConnectionFactory, XATopicConnectionFactory
  All Known Implementing Classes:
    BasicConnectionFactory, ConnectionFactory, QueueConnectionFactory, TopicConnectionFactory, XAConnectionFactory, XAQueueConnectionFactory, XATopicConnectionFactory

      public interface ConnectionFactory

  A `ConnectionFactory` object encapsulates a set of connection configuration parameters that has been defined by an administrator. A client uses it to create a connection with a JMS provider.

  A `ConnectionFactory` object is a JMS administered object and supports concurrent use.

  JMS administered objects are objects containing configuration information that are created by an administrator and later used by JMS clients. They make it practical to administer the JMS API in the enterprise.

  Although the interfaces for administered objects do not explicitly depend on the Java Naming and Directory Interface (JNDI) API, the JMS API establishes the convention that JMS clients find administered objects by looking them up in a JNDI namespace.

  An administrator can place an administered object anywhere in a namespace. The JMS API does not define a naming policy.

  It is expected that JMS providers will provide the tools an administrator needs to create and configure administered objects in a JNDI namespace. JMS provider implementations of administered objects should be both `javax.jndi.Referenceable` and `java.io.Serializable` so that they can be stored in all JNDI naming contexts. In addition, it is recommended that these implementations follow the JavaBeansTM design patterns.

  This strategy provides several benefits:

  - It hides provider-specific details from JMS clients.
  - It abstracts administrative information into objects in the Java programming language ("Java objects") that are easily organized and administered from a common management console.
  - Since there will be JNDI providers for all popular naming services, this means that JMS providers can deliver one implementation of administered objects that will run everywhere.

  An administered object should not hold on to any remote resources. Its lookup should not use remote resources other than those used by the JNDI API itself.

  Clients should think of administered objects as local Java objects. Looking them up should not have any hidden side effects or use surprising amounts of local resources.

  Since:
    JMS 1.0
  See Also:
    `Connection`, `QueueConnectionFactory`, `TopicConnectionFactory`

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Connection` | `createConnection()` Creates a connection with the default user identity.
    `Connection` | `createConnection(String userName, String password)` Creates a connection with the specified user identity.
    `JMSContext` | `createContext()` Creates a JMSContext with the default user identity and an unspecified sessionMode.
    `JMSContext` | `createContext(int sessionMode)` Creates a JMSContext with the default user identity and the specified session mode.
    `JMSContext` | `createContext(String userName, String password)` Creates a JMSContext with the specified user identity and an unspecified sessionMode.
    `JMSContext` | `createContext(String userName, String password, int sessionMode)` Creates a JMSContext with the specified user identity and the specified session mode.

- - ### Method Detail

    - #### createConnection

          Connection createConnection()
                                      throws JMSException

      Creates a connection with the default user identity. The connection is created in stopped mode. No messages will be delivered until the `Connection.start` method is explicitly called.
      Returns:
        a newly created connection
      Throws:
        `JMSException` - if the JMS provider fails to create the connection due to some internal error.
        `JMSSecurityException` - if client authentication fails due to an invalid user name or password.
      Since:
        JMS 1.1

    - #### createConnection

          Connection createConnection(String userName,
                                    String password)
                                      throws JMSException

      Creates a connection with the specified user identity. The connection is created in stopped mode. No messages will be delivered until the `Connection.start` method is explicitly called.
      Parameters:
        `userName` - the caller's user name
        `password` - the caller's password
      Returns:
        a newly created connection
      Throws:
        `JMSException` - if the JMS provider fails to create the connection due to some internal error.
        `JMSSecurityException` - if client authentication fails due to an invalid user name or password.
      Since:
        JMS 1.1

    - #### createContext

          JMSContext createContext()

      Creates a JMSContext with the default user identity and an unspecified sessionMode.

      A connection and session are created for use by the new JMSContext. The connection is created in stopped mode but will be automatically started when a JMSConsumer is created.

      The behaviour of the session that is created depends on whether this method is called in a Java SE environment, in the Java EE application client container, or in the Java EE web or EJB container. If this method is called in the Java EE web or EJB container then the behaviour of the session also depends on whether or not there is an active JTA transaction in progress.

      In a Java SE environment or in the Java EE application client container:

      - The session will be non-transacted and received messages will be acknowledged automatically using an acknowledgement mode of `JMSContext.AUTO_ACKNOWLEDGE` For a definition of the meaning of this acknowledgement mode see the link below.

      In a Java EE web or EJB container, when there is an active JTA transaction in progress:

      - The session will participate in the JTA transaction and will be committed or rolled back when that transaction is committed or rolled back, not by calling the `JMSContext`'s `commit` or `rollback` methods.

      In the Java EE web or EJB container, when there is no active JTA transaction in progress:

      - The session will be non-transacted and received messages will be acknowledged automatically using an acknowledgement mode of `JMSContext.AUTO_ACKNOWLEDGE` For a definition of the meaning of this acknowledgement mode see the link below.
      Returns:
        a newly created JMSContext
      Throws:
        `JMSRuntimeException` - if the JMS provider fails to create the JMSContext due to some internal error.
        `JMSSecurityRuntimeException` - if client authentication fails due to an invalid user name or password.
      Since:
        JMS 2.0
      See Also:
        `JMSContext.AUTO_ACKNOWLEDGE`, `createContext(int)`, `createContext(java.lang.String, java.lang.String)`, `createContext(java.lang.String, java.lang.String, int)`, `JMSContext.createContext(int)`

    - #### createContext

          JMSContext createContext(String userName,
                                 String password)

      Creates a JMSContext with the specified user identity and an unspecified sessionMode.

      A connection and session are created for use by the new JMSContext. The connection is created in stopped mode but will be automatically started when a JMSConsumer.

      The behaviour of the session that is created depends on whether this method is called in a Java SE environment, in the Java EE application client container, or in the Java EE web or EJB container. If this method is called in the Java EE web or EJB container then the behaviour of the session also depends on whether or not there is an active JTA transaction in progress.

      In a Java SE environment or in the Java EE application client container:

      - The session will be non-transacted and received messages will be acknowledged automatically using an acknowledgement mode of `JMSContext.AUTO_ACKNOWLEDGE` For a definition of the meaning of this acknowledgement mode see the link below.

      In a Java EE web or EJB container, when there is an active JTA transaction in progress:

      - The session will participate in the JTA transaction and will be committed or rolled back when that transaction is committed or rolled back, not by calling the `JMSContext`'s `commit` or `rollback` methods.

      In the Java EE web or EJB container, when there is no active JTA transaction in progress:

      - The session will be non-transacted and received messages will be acknowledged automatically using an acknowledgement mode of `JMSContext.AUTO_ACKNOWLEDGE` For a definition of the meaning of this acknowledgement mode see the link below.
      Parameters:
        `userName` - the caller's user name
        `password` - the caller's password
      Returns:
        a newly created JMSContext
      Throws:
        `JMSRuntimeException` - if the JMS provider fails to create the JMSContext due to some internal error.
        `JMSSecurityRuntimeException` - if client authentication fails due to an invalid user name or password.
      Since:
        JMS 2.0
      See Also:
        `JMSContext.AUTO_ACKNOWLEDGE`, `createContext()`, `createContext(int)`, `createContext(java.lang.String, java.lang.String, int)`, `JMSContext.createContext(int)`

    - #### createContext

          JMSContext createContext(String userName,
                                 String password,
                                 int sessionMode)

      Creates a JMSContext with the specified user identity and the specified session mode.

      A connection and session are created for use by the new JMSContext. The JMSContext is created in stopped mode but will be automatically started when a JMSConsumer is created.

      The effect of setting the `sessionMode` argument depends on whether this method is called in a Java SE environment, in the Java EE application client container, or in the Java EE web or EJB container. If this method is called in the Java EE web or EJB container then the effect of setting the `sessionMode` argument also depends on whether or not there is an active JTA transaction in progress.

      In a Java SE environment or in the Java EE application client container:

      - If `sessionMode` is set to `JMSContext.SESSION_TRANSACTED` then the session will use a local transaction which may subsequently be committed or rolled back by calling the `JMSContext`'s `commit` or `rollback` methods.
      - If `sessionMode` is set to any of `JMSContext.CLIENT_ACKNOWLEDGE`, `JMSContext.AUTO_ACKNOWLEDGE` or `JMSContext.DUPS_OK_ACKNOWLEDGE`. then the session will be non-transacted and messages received by this session will be acknowledged according to the value of `sessionMode`. For a definition of the meaning of these acknowledgement modes see the links below.

      In a Java EE web or EJB container, when there is an active JTA transaction in progress:

      - The argument `sessionMode` is ignored. The session will participate in the JTA transaction and will be committed or rolled back when that transaction is committed or rolled back, not by calling the `JMSContext`'s `commit` or `rollback` methods. Since the argument is ignored, developers are recommended to use `createSession()`, which has no arguments, instead of this method.

      In the Java EE web or EJB container, when there is no active JTA transaction in progress:

      - The argument `acknowledgeMode` must be set to either of `JMSContext.AUTO_ACKNOWLEDGE` or `JMSContext.DUPS_OK_ACKNOWLEDGE`. The session will be non-transacted and messages received by this session will be acknowledged automatically according to the value of `acknowledgeMode`. For a definition of the meaning of these acknowledgement modes see the links below. The values `JMSContext.SESSION_TRANSACTED` and `JMSContext.CLIENT_ACKNOWLEDGE` may not be used.
      Parameters:
        `userName` - the caller's user name
        `password` - the caller's password
        `sessionMode` - indicates which of four possible session modes will be used.
        - If this method is called in a Java SE environment or in the Java EE application client container, the permitted values are `JMSContext.SESSION_TRANSACTED`, `JMSContext.CLIENT_ACKNOWLEDGE`, `JMSContext.AUTO_ACKNOWLEDGE` and `JMSContext.DUPS_OK_ACKNOWLEDGE`.
        - If this method is called in the Java EE web or EJB container when there is an active JTA transaction in progress then this argument is ignored.
        - If this method is called in the Java EE web or EJB container when there is no active JTA transaction in progress, the permitted values are `JMSContext.AUTO_ACKNOWLEDGE` and `JMSContext.DUPS_OK_ACKNOWLEDGE`. In this case the values `JMSContext.TRANSACTED` and `JMSContext.CLIENT_ACKNOWLEDGE` are not permitted.
      Returns:
        a newly created JMSContext
      Throws:
        `JMSRuntimeException` - if the JMS provider fails to create the JMSContext due to some internal error.
        `JMSSecurityRuntimeException` - if client authentication fails due to an invalid user name or password.
      Since:
        JMS 2.0
      See Also:
        `JMSContext.SESSION_TRANSACTED`, `JMSContext.CLIENT_ACKNOWLEDGE`, `JMSContext.AUTO_ACKNOWLEDGE`, `JMSContext.DUPS_OK_ACKNOWLEDGE`, `createContext()`, `createContext(int)`, `createContext(java.lang.String, java.lang.String)`, `JMSContext.createContext(int)`

    - #### createContext

          JMSContext createContext(int sessionMode)

      Creates a JMSContext with the default user identity and the specified session mode.

      A connection and session are created for use by the new JMSContext. The JMSContext is created in stopped mode but will be automatically started when a JMSConsumer is created.

      The effect of setting the `sessionMode` argument depends on whether this method is called in a Java SE environment, in the Java EE application client container, or in the Java EE web or EJB container. If this method is called in the Java EE web or EJB container then the effect of setting the `sessionMode` argument also depends on whether or not there is an active JTA transaction in progress.

      In a Java SE environment or in the Java EE application client container:

      - If `sessionMode` is set to `JMSContext.SESSION_TRANSACTED` then the session will use a local transaction which may subsequently be committed or rolled back by calling the `JMSContext`'s `commit` or `rollback` methods.
      - If `sessionMode` is set to any of `JMSContext.CLIENT_ACKNOWLEDGE`, `JMSContext.AUTO_ACKNOWLEDGE` or `JMSContext.DUPS_OK_ACKNOWLEDGE`. then the session will be non-transacted and messages received by this session will be acknowledged according to the value of `sessionMode`. For a definition of the meaning of these acknowledgement modes see the links below.

      In a Java EE web or EJB container, when there is an active JTA transaction in progress:

      - The argument `sessionMode` is ignored. The session will participate in the JTA transaction and will be committed or rolled back when that transaction is committed or rolled back, not by calling the `JMSContext`'s `commit` or `rollback` methods. Since the argument is ignored, developers are recommended to use `createSession()`, which has no arguments, instead of this method.

      In the Java EE web or EJB container, when there is no active JTA transaction in progress:

      - The argument `acknowledgeMode` must be set to either of `JMSContext.AUTO_ACKNOWLEDGE` or `JMSContext.DUPS_OK_ACKNOWLEDGE`. The session will be non-transacted and messages received by this session will be acknowledged automatically according to the value of `acknowledgeMode`. For a definition of the meaning of these acknowledgement modes see the links below. The values `JMSContext.SESSION_TRANSACTED` and `JMSContext.CLIENT_ACKNOWLEDGE` may not be used.
      Parameters:
        `sessionMode` - indicates which of four possible session modes will be used.
        - If this method is called in a Java SE environment or in the Java EE application client container, the permitted values are `JMSContext.SESSION_TRANSACTED`, `JMSContext.CLIENT_ACKNOWLEDGE`, `JMSContext.AUTO_ACKNOWLEDGE` and `JMSContext.DUPS_OK_ACKNOWLEDGE`.
        - If this method is called in the Java EE web or EJB container when there is an active JTA transaction in progress then this argument is ignored.
        - If this method is called in the Java EE web or EJB container when there is no active JTA transaction in progress, the permitted values are `JMSContext.AUTO_ACKNOWLEDGE` and `JMSContext.DUPS_OK_ACKNOWLEDGE`. In this case the values `JMSContext.TRANSACTED` and `JMSContext.CLIENT_ACKNOWLEDGE` are not permitted.
      Returns:
        a newly created JMSContext
      Throws:
        `JMSRuntimeException` - if the JMS provider fails to create the JMSContext due to some internal error.
        `JMSSecurityRuntimeException` - if client authentication fails due to an invalid user name or password.
      Since:
        JMS 2.0
      See Also:
        `JMSContext.SESSION_TRANSACTED`, `JMSContext.CLIENT_ACKNOWLEDGE`, `JMSContext.AUTO_ACKNOWLEDGE`, `JMSContext.DUPS_OK_ACKNOWLEDGE`, `createContext()`, `createContext(java.lang.String, java.lang.String)`, `createContext(java.lang.String, java.lang.String, int)`, `JMSContext.createContext(int)`

Copyright (c) 2014, Oracle and/or its affiliates. All rights reserved.